; == EARLY WAR STANDARD RESOURCES ==
(define "standard_all"
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			(include "global_parameters/unitlimits.inc")
			{chargeFactors
				{value "*=1.00"}
			}
			{balancingFactorBonus	;// only affects players on team A (not bots)
				{chargeDelay 1}		;// adjusts the initial delay only
				{charge 1.0}		;// adjusts the interval only
			}
			(include "global_parameters/last_stand/budget_defender.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			(include "global_parameters/unitlimits.inc")
			{chargeFactors
				{value "*=1.00"}
			}
			(include "global_parameters/last_stand/budget_attacker.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_standard.inc" period("early") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)


; == EARLY WAR CUSTOM RESOURCES ==
(define "custom_all"
	{common
		{chargeFactors
			{value "*=1.00"}
			{customize "0;0.25;0.5;1;2"}
		}
	}
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			(include "global_parameters/unitlimits.inc")
			(include "global_parameters/last_stand/budget_defender_custom.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			(include "global_parameters/unitlimits.inc")
			(include "global_parameters/last_stand/budget_attacker_custom.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_custom.inc" period("early") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)


; == EARLY WAR TEST ==
(define "test_early"
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			{unitLimits ""}
			{chargeFactors
				{value "*=0"}
			}
			(include "global_parameters/last_stand/budget_defender.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "early^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			{unitLimits ""}
			{chargeFactors
				{value "*=0"}
			}
			(include "global_parameters/last_stand/budget_attacker.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_standard.inc" period("early") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)

;------------------------------------------------------------------------------------------------------------
{presets
	{"s:early_standard_80"
		{gameMode "standard"}
		{unitMode "early"}
		{specMode "all_normal"}
		{apply "only_roster_early"}
		("standard_all"			start_a(500) finish_a(1500) start_b(500) finish_b(3250) doctrine(200) cp_a(0:80,900:100,1500:120) cp_b(0:120,900:160,1500:220))
		{ranked}
	}
;------------------------------------------------------------------------------------------------------------

; // custom games here

	{"c:early_custom_20"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_20"}
		{apply "only_roster_early"}
		("custom_all"			start_a(400) finish_a(500) start_b(400) finish_b(1150) doctrine(0) cp_a(0:20,900:40,1500:60) cp_b(0:80,900:120,1500:180))
	}
	{"c:early_custom_40"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_40_ls"}
		{apply "only_roster_early"}
		("custom_all"			start_a(450) finish_a(1000) start_b(450) finish_b(2200) doctrine(100) cp_a(0:40,900:60,1500:80) cp_b(0:100,900:140,1500:200))
	}
	{"c:early_custom_40_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_40_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(450) finish_a(1000) start_b(450) finish_b(2200) doctrine(0) cp_a(0:40,900:60,1500:80) cp_b(0:100,900:140,1500:200))
	}	
	{"c:early_custom_60"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_60_ls"}
		{apply "only_roster_early"}
		("custom_all"			start_a(500) finish_a(1500) start_b(500) finish_b(3250) doctrine(200) cp_a(0:60,900:80,1500:100) cp_b(0:120,900:160,1500:220))
	}
	{"c:early_custom_60_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_60_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(500) finish_a(1500) start_b(500) finish_b(3250) doctrine(0) cp_a(0:60,900:80,1500:100) cp_b(0:120,900:160,1500:220))
	}
	{"c:early_custom_80"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_80"}
		{apply "only_roster_early"}
		("custom_all"			start_a(550) finish_a(2000) start_b(550) finish_b(4300) doctrine(200) cp_a(0:80,900:100,1500:120) cp_b(0:140,900:180,1500:240))
	}
	{"c:early_custom_80_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_80_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(550) finish_a(2000) start_b(550) finish_b(4300) doctrine(0) cp_a(0:80,900:100,1500:120) cp_b(0:140,900:180,1500:240))
	}	
	{"c:early_custom_100"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_100"}
		{apply "only_roster_early"}
		("custom_all"			start_a(600) finish_a(2500) start_b(600) finish_b(5450) doctrine(200) cp_a(0:100,900:120,1500:140) cp_b(0:160,900:200,1500:260))
	}
	{"c:early_custom_100_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_100_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(600) finish_a(2500) start_b(600) finish_b(5450) doctrine(0) cp_a(0:100,900:120,1500:140) cp_b(0:160,900:200,1500:260))
	}
	{"c:early_custom_0_dp_200"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_0_dp_200"}
		{apply "only_roster_early"}
		("custom_all"			start_a(0) finish_a(0) start_b(0) finish_b(0) doctrine(200) cp_a(0:0,0:0,0:0) cp_b(0:0,0:0,0:0))
	}		
	{"c:early_custom_120"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_120"}
		{apply "only_roster_early"}
		("custom_all"			start_a(650) finish_a(3000) start_b(650) finish_b(6500) doctrine(200) cp_a(0:120,900:140,1500:160) cp_b(0:180,900:220,1500:280))
	}
	{"c:early_custom_120_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_120_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(650) finish_a(3000) start_b(650) finish_b(6500) doctrine(0) cp_a(0:120,900:140,1500:160) cp_b(0:180,900:220,1500:280))
	}
	{"c:early_custom_140"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_140"}
		{apply "only_roster_early"}
		("custom_all"			start_a(700) finish_a(3500) start_b(700) finish_b(7550) doctrine(200) cp_a(0:140,900:160,1500:180) cp_b(0:200,900:240,1500:300))
	}
	{"c:early_custom_140_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_140_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(700) finish_a(3500) start_b(700) finish_b(7550) doctrine(0) cp_a(0:140,900:160,1500:180) cp_b(0:200,900:240,1500:300))
	}
	{"c:early_custom_160"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_160"}
		{apply "only_roster_early"}
		("custom_all"			start_a(750) finish_a(4000) start_b(750) finish_b(8600) doctrine(200) cp_a(0:160,900:180,1500:200) cp_b(0:220,900:260,1500:320))
	}
	{"c:early_custom_160_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_160_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(750) finish_a(4000) start_b(750) finish_b(8600) doctrine(0) cp_a(0:160,900:180,1500:200) cp_b(0:220,900:260,1500:320))
	}
	{"c:early_custom_180"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_180"}
		{apply "only_roster_early"}
		("custom_all"			start_a(800) finish_a(4500) start_b(800) finish_b(9650) doctrine(200) cp_a(0:180,900:200,1500:220) cp_b(0:240,900:280,1500:340))
	}
	{"c:early_custom_180_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_180_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(800) finish_a(4500) start_b(800) finish_b(9650) doctrine(0) cp_a(0:180,900:200,1500:220) cp_b(0:240,900:280,1500:340))
	}
	{"c:early_custom_200"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_200"}
		{apply "only_roster_early"}
		("custom_all"			start_a(850) finish_a(4500) start_b(850) finish_b(10700) doctrine(200) cp_a(0:200,900:220,1500:240) cp_b(0:260,900:300,1500:360))
	}
	{"c:early_custom_200_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_200_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(850) finish_a(4500) start_b(850) finish_b(10700) doctrine(0) cp_a(0:200,900:220,1500:240) cp_b(0:260,900:300,1500:360))
	}
	{"c:early_custom_250"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_250_ls"}
		{apply "only_roster_early"}
		("custom_all"			start_a(975) finish_a(4500) start_b(975) finish_b(13325) doctrine(500) cp_a(0:250,900:270,1500:290) cp_b(0:310,900:350,1500:410))
	}
	{"c:early_custom_250_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_250_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start_a(975) finish_a(4500) start_b(975) finish_b(13325) doctrine(0) cp_a(0:250,900:270,1500:290) cp_b(0:310,900:350,1500:410))
	}
;------------------------------------------------------------------------------------------------------------

	{"s:test_early"
		{gameMode "test"}
		{unitMode "early"}
		{specMode "all_normal"}
		{apply "only_roster_early"}
		("test_early"			start_a(50000) finish_a(50000) start_b(50000) finish_b(50000) doctrine(2000) cp_a(1000) cp_b(1000))
	}
}