; == mid WAR STANDARD RESOURCES ==
(define "standard_all"
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			(include "global_parameters/unitlimits.inc")
			{chargeFactors
				{value "*=1.00"}
			}
			{balancingFactorBonus	;// only affects players on team A (not bots)
				{chargeDelay 1}		;// adjusts the initial delay only
				{charge 1.0}		;// adjusts the interval only
			}
			(include "global_parameters/last_stand/budget_defender.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			(include "global_parameters/unitlimits.inc")
			{chargeFactors
				{value "*=1.00"}
			}
			(include "global_parameters/last_stand/budget_attacker.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_standard.inc" period("mid") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)


; == MID WAR CUSTOM RESOURCES ==
(define "custom_all"
	{common
		{chargeFactors
			{value "*=1.00"}
			{customize "0;0.25;0.5;1;2"}
		}
	}
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			(include "global_parameters/unitlimits.inc")
			(include "global_parameters/last_stand/budget_defender_custom.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			(include "global_parameters/unitlimits.inc")
			(include "global_parameters/last_stand/budget_defender_custom.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_custom.inc" period("mid") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)


; == MID WAR TEST ==
(define "test_mid"
	{teams
		{a ;// PLAYER DEFENDER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_a"}
			{unitLimits ""}
			{chargeFactors
				{value "*=0"}
			}
			(include "global_parameters/last_stand/budget_defender.inc" s(%start_a) f(%finish_a) d(%doctrine))
		}
		{b ;// AI ATTACKER TEAM
			{unitset
				{value "mid^conquestonly|doctrineonly"}
			}
			{commandPoints "*=%cp_b"}
			{unitLimits ""}
			{chargeFactors
				{value "*=0"}
			}
			(include "global_parameters/last_stand/budget_attacker.inc" s(%start_b) f(%finish_b) d(%doctrine))
		}
	}

	{bots
		(include "global_parameters/last_stand/bots_standard.inc" period("mid") start_a(%start_a) finish_a(%finish_a) start_b(%start_b) finish_b(%finish_b) doctrine(%doctrine) cp_a(%cp_a) cp_b(%cp_b))
	}
)

;------------------------------------------------------------------------------------------------------------
{presets
	{"s:mid_standard_80"
		{gameMode "standard"}
		{unitMode "mid"}
		{specMode "all_normal"}
		{apply "only_roster_mid"}
		("standard_all"			start_a(500) finish_a(1650) start_b(500) finish_b(3600) doctrine(200) cp_a(0:80,900:100,1500:120) cp_b(0:120,900:160,1500:220))
		{ranked}
	}
;------------------------------------------------------------------------------------------------------------

; // custom games here

	{"c:mid_custom_20"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_20"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(400) finish_a(550) start_b(400) finish_b(1200) doctrine(0) cp_a(0:20,900:40,1500:60) cp_b(0:80,900:120,1500:180))
	}
	{"c:mid_custom_40"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_40_ls"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(450) finish_a(1100) start_b(450) finish_b(2400) doctrine(100) cp_a(0:40,900:60,1500:80) cp_b(0:100,900:140,1500:200))
	}
	{"c:mid_custom_40_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_40_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(450) finish_a(1100) start_b(450) finish_b(2400) doctrine(0) cp_a(0:40,900:60,1500:80) cp_b(0:100,900:140,1500:200))
	}	
	{"c:mid_custom_60"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_60_ls"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(500) finish_a(1650) start_b(500) finish_b(3600) doctrine(200) cp_a(0:60,900:80,1500:100) cp_b(0:120,900:160,1500:220))
	}
	{"c:mid_custom_60_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_60_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(500) finish_a(1650) start_b(500) finish_b(3600) doctrine(0) cp_a(0:60,900:80,1500:100) cp_b(0:120,900:160,1500:220))
	}
	{"c:mid_custom_80"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_80"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(550) finish_a(2200) start_b(550) finish_b(4800) doctrine(200) cp_a(0:80,900:100,1500:120) cp_b(0:140,900:180,1500:240))
	}
	{"c:mid_custom_80_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_80_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(550) finish_a(2200) start_b(550) finish_b(4800) doctrine(0) cp_a(0:80,900:100,1500:120) cp_b(0:140,900:180,1500:240))
	}	
	{"c:mid_custom_100"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_100"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(600) finish_a(2750) start_b(600) finish_b(5000) doctrine(200) cp_a(0:100,900:120,1500:140) cp_b(0:160,900:200,1500:260))
	}
	{"c:mid_custom_100_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_100_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(600) finish_a(2750) start_b(600) finish_b(5000) doctrine(0) cp_a(0:100,900:120,1500:140) cp_b(0:160,900:200,1500:260))
	}
	{"c:mid_custom_0_dp_200"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_0_dp_200"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(0) finish_a(0) start_b(0) finish_b(0) doctrine(200) cp_a(0:0,0:0,0:0) cp_b(0:0,0:0,0:0))
	}		
	{"c:mid_custom_120"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_120"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(650) finish_a(3300) start_b(650) finish_b(7200) doctrine(200) cp_a(0:120,900:140,1500:160) cp_b(0:180,900:220,1500:280))
	}
	{"c:mid_custom_120_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_120_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(650) finish_a(3300) start_b(650) finish_b(7200) doctrine(0) cp_a(0:120,900:140,1500:160) cp_b(0:180,900:220,1500:280))
	}
	{"c:mid_custom_140"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_140"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(700) finish_a(3850) start_b(700) finish_b(8400) doctrine(200) cp_a(0:140,900:160,1500:180) cp_b(0:200,900:240,1500:300))
	}
	{"c:mid_custom_140_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_140_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(700) finish_a(3850) start_b(700) finish_b(8400) doctrine(0) cp_a(0:140,900:160,1500:180) cp_b(0:200,900:240,1500:300))
	}
	{"c:mid_custom_160"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_160"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(750) finish_a(4400) start_b(750) finish_b(9600) doctrine(200) cp_a(0:160,900:180,1500:200) cp_b(0:220,900:260,1500:320))
	}
	{"c:mid_custom_160_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_160_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(750) finish_a(4400) start_b(750) finish_b(9600) doctrine(0) cp_a(0:160,900:180,1500:200) cp_b(0:220,900:260,1500:320))
	}
	{"c:mid_custom_180"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_180"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(800) finish_a(4950) start_b(800) finish_b(10800) doctrine(200) cp_a(0:180,900:200,1500:220) cp_b(0:240,900:280,1500:340))
	}
	{"c:mid_custom_180_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_180_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(800) finish_a(4950) start_b(800) finish_b(10800) doctrine(0) cp_a(0:180,900:200,1500:220) cp_b(0:240,900:280,1500:340))
	}
	{"c:mid_custom_200"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_200"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(850) finish_a(5500) start_b(850) finish_b(12000) doctrine(200) cp_a(0:200,900:220,1500:240) cp_b(0:260,900:300,1500:360))
	}
	{"c:mid_custom_200_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_200_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(850) finish_a(5500) start_b(850) finish_b(12000) doctrine(0) cp_a(0:200,900:220,1500:240) cp_b(0:260,900:300,1500:360))
	}
	{"c:mid_custom_250"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_250_ls"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(975) finish_a(7275) start_b(975) finish_b(13800) doctrine(500) cp_a(0:250,900:270,1500:290) cp_b(0:310,900:350,1500:410))
	}
	{"c:mid_custom_250_dp_0"
		{gameMode "custom"}
		{unitMode "mid"}
		{specMode "cp_250_dp_0"}
		{apply "only_roster_mid"}
		("custom_all"			start_a(975) finish_a(7275) start_b(975) finish_b(13800) doctrine(0) cp_a(0:250,900:270,1500:290) cp_b(0:310,900:350,1500:410))
	}

;------------------------------------------------------------------------------------------------------------

	{"s:test_mid"
		{gameMode "test"}
		{unitMode "mid"}
		{specMode "all_normal"}
		{apply "only_roster_mid"}
		("test_mid"			start_a(50000) finish_a(50000) start_b(50000) finish_b(50000) doctrine(2000) cp_a(1000) cp_b(1000))
	}
}