; == EARLY WAR STANDARD RESOURCES ==
(define "standard_all"
	{common
		{unitset
			{value "early^conquestonly|doctrineonly"}
		}
		{commandPoints "*=%cp"}
		(include "global_parameters/unitlimits.inc")
		{chargeFactors
			{value "*=1.00"}
		}
		(include "global_parameters/budget.inc" s(%start) f(%finish) d(%doctrine))
	}
	{bots
		(include "global_parameters/bots_generic.inc" period("early"))
	}
)

; == EARLY WAR CUSTOM RESOURCES ==
(define "custom_all"
	{common
		{unitset
			{value "early^conquestonly|doctrineonly"}
			{available "infsquad at_squad infmortar elitesquad infsingle inf_tm engineer tankcrew flamer medic sniper officer radioman supply emplacement mg_crew mortar cannon lightcan mediumcan heavycan artillery mediumart heavyart rocket vehicle wheel light medium heavy spg air"}																							
		}
		{commandPoints "*=%cp"}
		(include "global_parameters/unitlimits.inc")
		{chargeFactors
			{value "*=1.00"}
			{customize "0;0.25;0.5;1;2"}
		}
		(include "global_parameters/budget_custom.inc" s(%start) f(%finish) d(%doctrine))
	}
	{bots
		(include "global_parameters/bots_generic.inc" period("early"))
	}
)

;------------------------------------------------------------------------------------------------------------
{presets
	{"s:early_standard_100"
		{gameMode "standard"}
		{unitMode "early"}
		{specMode "all_normal"}
		{apply "only_roster_early"}
		("standard_all"			start(200) finish(2650) doctrine(200) cp(0:100,900:150,1500:200))
		{ranked}
	}
;------------------------------------------------------------------------------------------------------------	

	{"c:early_custom_12"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_12"}
		{apply "only_roster_early"}
		("custom_all"			start(12) finish(20) doctrine(0) cp(0:12,900:16,1500:20))
		{ranked}
	}
	{"c:early_custom_20"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_20"}
		{apply "only_roster_early"}
		("custom_all"			start(20) finish(200) doctrine(0) cp(0:20,900:30,1500:40))
		{ranked}
	}
	{"c:early_custom_40"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_40"}
		{apply "only_roster_early"}
		("custom_all"			start(40) finish(2000) doctrine(0) cp(0:40,900:60,1500:80))
		{ranked}
	}
	{"c:early_custom_60"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_60"}
		{apply "only_roster_early"}
		("custom_all"			start(60) finish(2000) doctrine(100) cp(0:60,900:80,1500:100))
		{ranked}
	}
	{"c:early_custom_60_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_60_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(60) finish(2000) doctrine(0) cp(0:60,900:80,1500:100))
		{ranked}
	}	
	{"c:early_custom_80"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_80"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(2150) doctrine(200) cp(0:80,900:130,1500:180))
	}
		{"c:early_custom_80_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_80_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(2800) doctrine(0) cp(0:80,900:130,1500:180))
	}
	{"c:early_custom_100"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_100"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(2650) doctrine(200) cp(0:100,900:150,1500:200))
	}
	{"c:early_custom_100_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_100_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(3300) doctrine(0) cp(0:100,900:150,1500:200))
	}
	{"c:early_custom_0_dp_200"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_0_dp_200"}
		{apply "only_roster_early"}
		("custom_all"			start(0) finish(0) doctrine(200) cp(0:0,0:0,0:0))
	}			
	{"c:early_custom_120"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_120"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(3150) doctrine(200) cp(0:120,900:170,1500:220))
	}
	{"c:early_custom_120_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_120_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(3800) doctrine(0) cp(0:120,900:170,1500:220))
	}	
	{"c:early_custom_140"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_140"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(3650) doctrine(200) cp(0:140,900:190,1500:240))
	}
	{"c:early_custom_140_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_140_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(4300) doctrine(0) cp(0:140,900:190,1500:240))
	}	
	{"c:early_custom_160"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_160"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(4150) doctrine(200) cp(0:160,900:210,1500:260))
	}
	{"c:early_custom_160_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_160_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(4800) doctrine(0) cp(0:160,900:210,1500:260))
	}	
	{"c:early_custom_180"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_180"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(4650) doctrine(200) cp(0:180,900:230,1500:280))
	}
	{"c:early_custom_180_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_180_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(5300) doctrine(0) cp(0:180,900:230,1500:280))
	}	
	{"c:early_custom_200"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_200"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(5150) doctrine(200) cp(0:200,900:250,1500:300))
	}
	{"c:early_custom_200_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_200_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(5800) doctrine(0) cp(0:200,900:250,1500:300))
	}	
	{"c:early_custom_250"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_250"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(5650) doctrine(200) cp(0:250,900:300,1500:350))
	}
	{"c:early_custom_250_dp_0"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_250_dp_0"}
		{apply "only_roster_early"}
		("custom_all"			start(200) finish(6000) doctrine(0) cp(0:250,900:300,1500:350))
	}	
	{"c:early_custom_500"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_500"}
		{apply "only_roster_early"}
		("custom_all"			start(250) finish(7500) doctrine(300) cp(0:500,900:600,1500:750))
	}
	{"c:early_custom_750"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_750"}
		{apply "only_roster_early"}
		("custom_all"			start(375) finish(20000) doctrine(400) cp(0:750,900:900,1500:1000))
	}	
	{"c:early_custom_1000"
		{gameMode "custom"}
		{unitMode "early"}
		{specMode "cp_1000"}
		{apply "only_roster_early"}
		("custom_all"			start(500) finish(30000) doctrine(500) cp(0:1000,900:1200,1500:1500))	
	}		
;------------------------------------------------------------------------------------------------------------
}

;[LSB] UPDATED: v1.047.0 31OCT24
;Слава Україні!